-- #                _____              ___ ____     _ _
-- #               |  ___| __ ___  ___|_ _|  _ \ __| | |__
-- #               | |_ | '__/ _ \/ _ \| || |_) / _` | '_ \
-- #               |  _|| | |  __/  __/| ||  __/ (_| | |_) |
-- #               |_|  |_|  \___|\___|___|_|   \__,_|_.__/
-- #
-- #	DNS.sql-$Name:  $-$Revision: 1.1 $ $Date: 2002/02/04 05:27:24 $ <$Author: bapril $@freeipdb.org>
-- #####################################################################;


CREATE TABLE zone_record_table (
	ID		SERIAL,
	ZONE		INT NOT NULL,
	TYPE		INT NOT NULL,
	BLOCK		INT,
	INDEX		INT,
	HOSTNAME	VARCHAR(256),
	TEXT		VARCHAR(256),
	IP		NUMERIC(40,0)
);
GRANT ALL ON zone_record_table TO freeipdb;
GRANT ALL ON zone_record_table_id_seq TO freeipdb;

CREATE TABLE ZONE_TABLE (
	ID		SERIAL,
	NAME		VARCHAR(256) NOT NULL,
	PARENT		INT NOT NULL,
	OWN		BOOL,
	REVERSE_BLOCK	INT,
	SERIAL		INT, 
	RETRY		INT, 
	REFRESH		INT,
	EXPIRE		INT,
	TTL		INT
);
GRANT ALL ON ZONE_TABLE TO freeipdb;
GRANT ALL ON ZONE_TABLE_ID_SEQ TO freeipdb;

INSERT INTO ZONE_TABLE (NAME,PARENT,OWN) VALUES ('.',0,'f');
INSERT INTO ZONE_TABLE (NAME,PARENT,OWN) VALUES ('net',1,'f');
INSERT INTO ZONE_TABLE (NAME,PARENT,OWN) VALUES ('com',1,'f');
INSERT INTO ZONE_TABLE (NAME,PARENT,OWN) VALUES ('org',1,'f');
INSERT INTO ZONE_TABLE (NAME,PARENT,OWN) VALUES ('arpa',1,'f');
INSERT INTO ZONE_TABLE (NAME,PARENT,OWN) VALUES ('in-addr',8,'f');
