#                _____              ___ ____     _ _
#               |  ___| __ ___  ___|_ _|  _ \ __| | |__
#               | |_ | '__/ _ \/ _ \| || |_) / _` | '_ \
#               |  _|| | |  __/  __/| ||  __/ (_| | |_) |
#               |_|  |_|  \___|\___|___|_|   \__,_|_.__/
#
#	ipdb_httpcgi.pl-$Name:  $-$Revision: 1.27 $ $Date: 2002/03/30 02:07:18 $ <$Author: bapril $@freeipdb.org>
######################################################################

require 'ipdb_lib.pl';

######################################################################
# sub printHead
#
# prints the HTML header info, taking the title as a parameter
######################################################################
sub printHead {

my $title = shift (@_);

print <<EOM;
Content-type: text/html\n\n
<HTML>
 <HEAD>
  <TITLE>$title</TITLE>
 </HEAD>
 <BODY BGCOLOR=#FFFFFF>
EOM
}

######################################################################
# sub printTail
#
# Prints the end of the HTML page
######################################################################
sub printTail {
print <<'EOF';
  <ADDRESS>
   FreeIPdb
   Copyright <A HREF=mailto:ben@freeipdb.org>Benjamin D. April</A> & <A HREF=mailto:paul@freeipdb.org>Paul J. Benjes</A> 2001
  </ADDRESS>
 </BODY>
</HTML>
EOF
}

sub get_cgi(){
        $exe = shift;
        $exe =~ s/\/.*\/([^\/]*)$/$1/ ;
        return($exe);
}



sub GetNewBlock(){
	my $conn = shift;
	my $region = shift;
	my $bits = shift;
	my $CUSTDESC = shift;
	my $CUST = shift;
	my $newblock = &NewBlock($conn,$region,$bits,$CUSTDESC,$CUST) || &IPDBError(-1,"Could not create Block");
	print "  Your New BlockID is : $newblock\n";
	my $string = &ReadBlock($conn,$newblock);
	print "  <BR>$string<BR>";
	return($newblock);
}

sub ReclaimBlock(){
	my $conn = shift;
	my $block = shift;
	return(&reclaim($conn,$block));
}

sub IP2Deci(){
	my $block = shift;
	$out = ip2deci($block);
	return($out);
}

sub FreeList(){
	my $conn = shift;
	$query = "SELECT i.ID,i.BLOCK,i.BITS,r.name,r.v6,i.reclaim
		FROM IPDB i,REGIONTABLE r 
		WHERE r.ID = i.REGION 
			AND i.CHILDL IS NULL 
			AND CHILDR IS NULL 
			AND ALLOCATED IS NULL ORDER BY r.name,bits";
	my $str = $conn->prepare($query);
	my $num = $str->execute;;
	my $in = 0;
	my @out;
	while(@out = $str->fetchrow){
		my $id = $out[0];
		my $block = $out[1];
		my $bits = $out[2];
		my $region = $out[3];
		my $reclaim = $out[5];
		my $ver = &Version($conn,$id);
		$block = deci2ip($block,$ver);
		unless($reclaim){	
			$reclaim = "&nbsp;";
		} elsif ($reclaim eq "0") {
			$reclaim = "Child Block";
		} elsif ($reclaim eq "1") {
			$reclaim = "Master Block";
		}
		$in = &Toggle($in);
		print "<TD>$region</TD><TD>$block/$bits</TD><TD>$reclaim</TD><TD>$id</TD></TR>\n";
		$i++;
	}
	$str->finish;
	undef $str;
}

#--------------------------------------------------------------------------------------
#	AddBlock();
# Takes:
#	A database connection
#	A block (in integer format)
#	A Bitmask (in bits)
# Returns:
#	-1 on error
#	0 on block in use or parent exists
#	ID of block on sucess

sub AddBlock(){
	my $conn = shift;
	my $block = shift;
	my $bits = shift;
	my $region = shift;
	my $priority = shift;
	my $newblock = &NewAlloc($conn,$block,$bits,$region,$priority);
	return($newblock);
}


sub AllocatedSearch(){
	my $conn =	shift;
	my $script =	shift;
	my $class =	shift; # 1 for allowed to edit/reclaim 0 for not.
	my $id =	shift;
        my $block =	shift;
        my $bits =	shift;
        my $region =	shift;
	my $cust =	shift;
	my $custdesc = 	shift;
	my $hostname = 	shift;
	my $toggle =    shift;
	my $query = "SELECT ID FROM IPDB WHERE ID NOTNULL";
	if($id){
		$query = $query." AND ID = $id";
	} else {
		if($custdesc){$query = $query." AND CUSTDESC LIKE '%$custdesc%'";}
		if($cust){$query = $query." AND CUSTNUM LIKE '%$cust%'";}
		if($region !~ m/---/){$query = $query." AND REGION = $region";}
		if($bits =~ m/^[0-9]+$/){$query = $query." AND BITS = $bits";}
		if($block){ $query = $query." AND BLOCK = ".$block."::NUMERIC(40,0) "; }
		if($hostname){$query = $query." AND ZONE_RECORD_TABLE.hostname ~* '$hostname' AND ZONE_RECORD_TABLE.block = ID";}
	}
	$query = $query." ORDER BY BITS ASC";
	print "<!--$query-->\n";
	my $str = $conn->prepare($query);
	my $num = $str->execute;
	my $in = 0;
	print "<TR><TD COLSPAN=7>Direct search</TD></TR>\n";
	while(@out = $str->fetchrow){
		my $id = $out[0];
		$toggle = &SearchResult($conn,$id,$toggle,$script,$class);
		$i++;
	}
	#walk the list for eligible parent blocks.
	if($block){
		print "<TR><TD COLSPAN=7>Recurssive search</TD></TR>\n";
		$query = "SELECT ID,BLOCK,BITS,REGION,ALLOCATED,CHILDL,CHILDR FROM IPDB WHERE PARENT = 0";
		if($region){$query = $query." AND REGION = $region";}
		#if($bits =~ m/^[0-9]+$/){$query = $query." AND BITS = $bits";}
		$query = $query." AND BLOCK <= ".$block."::NUMERIC(40,0) "; 
		print "<!--$query-->\n";
		my $str = $conn->prepare($query);
		my $num = $str->execute;
		while(@out = $str->fetchrow){
			#Check of search-block is within parent.
			my $id = $out[0];
			my $start = $out[1];
			my $ver = &Version($conn,$id);
			my $size = &Addresses($out[2],$ver);
			my $end = $start + $size;
			my $childl = $out[5];
			my $childr = $out[6];
			if(($block >= $start) && ($block <= $end)){
				if($childl){
					&RecBlockSearch($conn,$childl,$block,$bits,$script,$class);
					&RecBlockSearch($conn,$childr,$block,$bits,$script,$class);
				} else {
					$toggle = &SearchResult($conn,$id,$toggle,$script,$class);
				}
			} 
		}
	}
}

sub RecBlockSearch(){
	my $conn = shift;
	my $id = shift;
	my $block = shift;
	my $bits = shift;
	my $script = shift;
	my $class = shift;
	$query = "SELECT ID,BLOCK,BITS,REGION,ALLOCATED,CHILDL,CHILDR FROM IPDB WHERE ID = $id";
	print "<!--$query-->\n";
	my $str = $conn->prepare($query);
	my $num = $str->execute;
	while(@out = $str->fetchrow){
		#Check of search-block is within parent.
		my $id = $out[0];
		my $start = $out[1];
		my $ver = &Version($conn,$id);
		my $size = &Addresses($out[2],$ver);
		my $end = $start + $size;
		my $childl = $out[5];
		my $childr = $out[6];
		if(($block >= $start) && ($block <= $end)){
			if($childl){
				&RecBlockSearch($conn,$childl,$block,$bits,$script,$class);
				&RecBlockSearch($conn,$childr,$block,$bits,$script,$class);
			} else {
				$toggle = &SearchResult($conn,$id,$toggle,$script,$class);
			}
		} 
	}
}

sub SearchResult(){
	my $conn = shift;
	my $id = shift;
	my $toggle = shift;
	my $script = shift;
	my $class = shift;
	$query = "SELECT BLOCK,BITS,REGION,ALLOCATED,CUSTDESC,CUSTNUM,CHILDL,CHILDR FROM IPDB WHERE ID = $id";
	print "<!--$query-->\n";
	my $str = $conn->prepare($query);
	my $num = $str->execute;
	$toggle = &Toggle($toggle);
	@out = $str->fetchrow;
	my $bits = $out[1];
	my $customer = $out[4];
	my $custdesc = $out[5];
	my $childl = $out[6];
	my $childr = $out[7];
	my $ver = &Version($conn,$id);
	my $block = &deci2ip($out[0],$ver);
	my $region = &LookupRegion($conn,$out[2]);
	print "<TD>$id</TD><TD>$block/$bits</TD><TD>$region</TD><TD>";
	if($out[3]){
		my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($out[3]);
		$mon++;
		$year += 1900;
		my $allocated = $hour.":".$min.":".$sec." ".$mon."/".$mday."/".$year;
		print "$allocated</TD>";
	} else {
		print "&nbsp;</TD>";
	}
	if($config{custnum}){
		if($customer){
			print "<TD>$customer</TD>";
		} else {
			print "<TD>&nbsp;</TD>";
		}
	}
	if($config{custname}){
		if($custdesc){
			print "<TD>$custdesc</TD>";
		} else {
			print "<TD>&nbsp;</TD>";
		}
	}
	print "<TD>";
	if($class && $out[3]){
		print "<FORM ACTION=$script METHOD=POST><INPUT TYPE=HIDDEN NAME=RECLAIM VALUE=$id>";
		print "<INPUT TYPE=HIDDEN NAME=ACTION VALUE=RECLAIM><INPUT TYPE=SUBMIT VALUE=RECLAIM></FORM>";
		print "<FORM ACTION=$script METHOD=POST><INPUT TYPE=HIDDEN NAME=EDIT VALUE=$id>";
		print "<INPUT TYPE=HIDDEN NAME=ACTION VALUE=EDIT><INPUT TYPE=SUBMIT VALUE=EDIT></FORM>";
	} elsif($childl){
		print "<FORM METHOD=POST><INPUT TYPE=HIDDEN NAME=RECURSE VALUE=$id>";
		print "<INPUT TYPE=HIDDEN NAME=ACTION VALUE=RECURSE><INPUT TYPE=HIDDEN NAME=CHILDL VALUE=$childl>";
		print "<INPUT TYPE=HIDDEN NAME=CHILDR VALUE=$childr><INPUT TYPE=SUBMIT VALUE=Drill-Down></FORM>";
	} else {
		print "&nbsp;";
	}
	print "</TD></TR>";
	if($config{allowDNS} && &CheckDNS($conn,$id)){
		&DNSTable($conn,$id,$script);
	}
	return($toggle);
}

sub EditForm(){
	my $conn = shift;
        my $id = shift;
	my $script = shift;
	my $query = "SELECT BLOCK,BITS,REGION,CUSTNUM,CUSTDESC FROM IPDB WHERE ID = $id";
	my $str = $conn->prepare($query);
	my $num = $str->execute;
	my $regionid;
	my $bits = "";
	my $customer = "";
	my $custdesc = "";
	$num =~ s/E.*//g;
	if($num){
		@out = $str->fetchrow;
		$block = deci2ip($out[0],Version($conn,$id));
		$bits = $out[1];
		$regionid = $out[2];
		$region = &LookupRegion($conn,$regionid);
		$customer = $out[3];
		$custdesc = $out[4];
	}
	print "<TABLE BORDER><TR><TH>ID</TH><TH>Block</TH><TH>Region</TH>\n";
	if($config{custnum}){
		print "<TH>$config{custnum_f}</TH>";
	} 
	if($config{custname}){
		print "<TH>$config{custname_f}</TH>";
	}
	print "<TH>Function</TH></TR>\n";
	print "<FORM ACTION=$script METHOD=POST>";
	print "<TR><TD>$id</TD><TD>$block/$bits</TD><TD><SELECT NAME=REGION>\n<OPTION> --- No change $region ---\n";
	
	ListRegions($conn);
	print "</SELECT>";
	print "</TD>";
	if($config{custnum}){
	print "<TD><INPUT NAME=CUSTOMER VALUE=$customer></TD>\n";
	}
	if($config{custname}){
	print "<TD><INPUT NAME=CUSTDESC VALUE=\"$custdesc\"></TD>\n";
	}
	print "<TD><INPUT TYPE=HIDDEN NAME=UPDATE  VALUE=$id>\n";
	print "<INPUT TYPE=HIDDEN NAME=ACTION VALUE=UPDATE><INPUT TYPE=SUBMIT VALUE=UPDATE></FORM>\n";
	print "</TD></TR>\n";
	print "</TABLE>";
	$i++;
}

sub UpdateBlock(){
	my $conn = shift;
	my $id = shift;
	my $region = shift;
	my $customer = shift;
	my $custdesc = shift;
	unless($region =~ m/---/){
		my @block = GetBlockFromID($conn,$id);
		my $ver = &Version($conn,$id);
		print "1";
		$ip = deci2ip($block[0],$ver);
		my $added = &SetBlockP($conn,$ip,$region,$block[1],1,1,$ver);
		print "2";
		if($added){
			print "A parent of that block exists.<BR>\n";
			&reclaim($conn,$added);
		} else {
			my $check = &CheckBlockFree($conn,$block[0],$block[1],$region);
			if($check){
				print "Block is in use<BR>\n";
				return(0);
			} else {
				if(&SetRegion($conn,$id,$region)){
					print "Success  $id!\n";
				} else {
					print "There was an error\n";
				}
			}
		}
	}
	if($custdesc){
		$str = $conn->prepare("UPDATE IPDB SET CUSTDESC = '$custdesc' WHERE ID = $id");
		$num = $str->execute();
		if($str->err){
			my $err = $DBI::errstr;
			&IPDBError(-1,"Could not update block info in IPDB $err");
		}
	}
	if($customer){
		$str = $conn->prepare("UPDATE IPDB SET CUSTNUM = $customer WHERE ID = $id");
		$num = $str->execute();
		if($str->err){
			my $err = $DBI::errstr;
			&IPDBError(-1,"Could not update block info in IPDB $err");
		}
	}
}

sub AllocatedSearch_Head(){
	print "<TABLE BORDER>\n";
	print "<TR><TH>Id</TH><TH>Block Bits</TH><TH>Region</TH><TH>Allocated</TH>\n";
	if($config{custname}){
		print "<TH>$config{custname_f}</TH>";
	}
	if($config{custnum}){
        	print "<TH>$config{custnum_f}</TH>";
	}
	print "<TH>Functions</TH></TR>\n";
}

#--------------------------------------------------------------------------------------
sub SetRegion(){
	$conn = shift;
	$id = shift;
	$region = shift;
	$str = $conn->prepare("UPDATE IPDB SET REGION = $region WHERE ID = $id");
	$str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		$str->finish;
		undef $str;
		&IPDBError(-1,"Could not set reason: $err");
	}
	$str->finish;
	undef $str;
	return(1);
}
#--------------------------------------------------------------------------------------

#--------------------------------------------------------------------------------------
sub SetReclaim(){
	my $conn = shift;
	my $id = shift;
	my $level = shift;
	my $str = $conn->prepare("UPDATE IPDB SET RECLAIM = $level WHERE ID = $id");
	$str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not set reason: $err");
	}
	if($level){print "Setting reclaim on blockID: $id<BR>\n";}
	$str = $conn->prepare("SELECT CHILDL,CHILDR FROM IPDB WHERE ID = $id");
	my $num = $str->execute;
	if($str->err){		
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not set reclaim $err");
	}
	$num =~ s/E.*//g;
	if($num){
		my @out = $str->fetchrow;
		my $childl = $out[0];
		if($childl){
			&SetReclaim($conn,$childl,0);
		}
		my $childr = $out[1];
		if($childr){
			&SetReclaim($conn,$childr,0);
		}
	}
	$str->finish;
	undef $str;
}

sub ReclaimSerial(){
        my $conn = shift;
        my $block = shift;
        my $str = $conn->prepare("DELETE FROM ZONE_RECORD_TABLE WHERE BLOCK = $block AND TYPE = 2");
	$str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not delete reverse entry $err");
	}
}

#Get block ID no mask needed (returns the ID of the block of the smallest size matching the criteria.

# Give an IP and a region.
#return the block ID and the off-set.

#Gen list of All blocks that are allocated and the block starts at a lower IP than the entered it.
# Walk the list and gen the last IP.
#Find the one that ends after this block.

sub GetBlockIdNM(){
	my $conn = shift;
	my $block = shift;
	my $region = shift;
        my $query = "SELECT ID,BLOCK,BITS FROM IPDB WHERE 
		BLOCK <= ".$block."::NUMERIC(40,0) 
		AND REGION = $region AND ALLOCATED NOTNULL 
		ORDER BY BLOCK DESC";
        my $str = $conn->prepare($query);
	my $num = $str->execute;
        if($str->err){ 
		my $err = $DBI::errstr;

		&IPDBError(-1,"Could not GetBlock List $err"); 
	}
	$i = 0;
	while(@out = $str->fetchrow){
                my $id = $out[0];
                my $start = $out[1];
               	my $bits = $out[2];
		my $ver = &Version($conn,$id);
		my $end = $start + &Addresses($bits,$ver);
		if($end >= $block){
			$foo[1] = $block - $start;
			$foo[0] = $id;
			return(@foo);
		}
		$i++;
        }
}

sub SetSerialDNS(){
        my $conn = shift;
        my $id = shift;
        my $cust = shift;
        my $port = shift;
        my $router = shift;
        my $zone = $router.".somewhere.net";
        my $zoneid = &GetZone($conn,$zone);
        $string1 = $port;
        $string2 = $cust.".".$port;
        &IncSerial($conn,$zoneid);
        &SetRevDNS($conn,$id,$zoneid,1,$string1);
        &SetRevDNS($conn,$id,$zoneid,2,$string2);
}

############ HERE ###################

sub SetRevDNS(){
        my $conn = shift;
        my $block = shift;
        my $zone = shift; # This is the forward zone.
        my $index = shift;
        my $string = shift;
        &IncSerial($conn,$zone);
	my $str = $conn->prepare("SELECT HOSTNAME FROM ZONE_RECORD_TABLE WHERE BLOCK = $block AND INDEX = $index AND TYPE = 2");
	my $num = $str->execute;
	if($str->err){ 
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not query for existing records: $err"); 
	}
	$num =~ s/E.*//g;
	if($num){
		print "<BR>Updating existing entry";
		$str = $conn->prepare("UPDATE ZONE_RECORD_TABLE SET HOSTNAME = '$string' WHERE BLOCK = $block AND INDEX = $index AND TYPE = 2");
		$str->execute;
		$str = $conn->prepare("UPDATE ZONE_RECORD_TABLE SET ZONE = $zone WHERE BLOCK = $block AND INDEX = $index AND TYPE = 2");
		$str->execute;
		if($str->err){
			my $err = $DBI::errstr;
			&IPDBError(-1,"Could not Update DNS record. $err"); 
		}
	} else {
		print "<BR>Adding new entry";
		$str = $conn->prepare("INSERT INTO ZONE_RECORD_TABLE (BLOCK,ZONE,INDEX,HOSTNAME,TYPE) VALUES ($block,$zone,$index,'$string',2)");
		$str->execute;
		if($str->err){
			my $err = $DBI::errstr;
			&IPDBError(-1,"Could not add new DNS record. $err"); 
		}
	}
}

sub SetFwdDNS(){
	my $conn = shift;
	my $block = shift;
	my $zone = shift;
	my $index = shift;
	my $string = shift;	
	&IncSerial($conn,$zone);
	print "<BR>Adding new entry";
	my $query = "INSERT INTO zone_record_table (ZONE,TYPE,BLOCK,INDEX,HOSTNAME) VALUES ($zone,1,$block,$index,'$string')";
	$str = $conn->prepare($query);
	$str->execute;
	if($str->err){ 
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not Add DNS record. $err ($zone,1,$block,$index,$string)"); 
	}
}

sub ClearRevDNS(){
	my $conn = shift;
	my $block = shift;
	my $str = $conn->prepare("SELECT ID FROM ZONE_TABLE WHERE REVERSE_BLOCK = $block");
	my $num = $str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not get used zone list. $err"); 
	}
	while(@out = $str->fetchrow){
		$zone = $out[0];
		IncSerial($conn,$zone);
		$i++;
	}
	$str = $conn->prepare("UPDATE ZONE_TABLE SET own = 'f' WHERE REVERSE_BLOCK = $block");
	$str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not update table $err"); 
	}
	$str = $conn->prepare("UPDATE ZONE_TABLE SET REVERSE_BLOCK = NULL WHERE REVERSE_BLOCK = $block");
	$str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not update table $err"); 
	}
	$str = $conn->prepare("DELETE FROM ZONE_RECORD_TABLE WHERE BLOCK = $block AND TYPE = 2");
	$str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not update table $err"); 
	}
	return(0);
}

sub SetRevZone(){
	my $conn = shift;
	my $block = shift;
	my $region = shift;
	@ip = split(/\./,$block);
        my $RevZoneName = "$ip[2].$ip[1].$ip[0].in-addr.arpa";
	my $RevZone = &GetZone($conn,$RevZoneName);
	my $blockname = "$ip[0].$ip[1].$ip[2].0";
	$block = &ip2deci($blockname);
	my $query = "SELECT ID FROM IPDB WHERE BLOCK <= ".$block."::NUMERIC(40,0) AND REGION = $region AND BITS = 24 ORDER BY BLOCK DESC";
	my $str = $conn->prepare($query);
	my $num = $str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not query Block from database. $err"); 
	}
	$num =~ s/E.*//g;
	if($num){
		@out = $str->fetchrow;
		$id = $out[0];
		$str = $conn->prepare("SELECT REVERSE_BLOCK FROM ZONE_TABLE WHERE ID = $RevZone");
		$str->execute;
		if($str->err){
			my $err = $DBI::errstr;
			&IPDBError(-1,"Could not pull from zone database. $err"); 
		}
		@out = $str->fetchrow;
		unless($out[0]){
			$str = $conn->prepare("UPDATE ZONE_TABLE SET REVERSE_BLOCK = $id WHERE ID = $RevZone");
			$str->execute;
			if($str->err){
				my $err = $DBI::errstr;
				&IPDBError(-1,"Could not update zone database. $err"); 
			}
		}
	} else {
		&IPDBError(-1,"Can't find matching block");
	}
	&IncSerial($conn,$RevZone);
}

sub GetZone(){
        my $conn = shift;
        my $zone = shift;
        my $i = 0;
        my @out;
	$out[0] = 1;
        my @Array = split(/\./,$zone);
        @array = reverse(@Array);
        while($array[$i] ne "" ){
                $str = $conn->prepare("SELECT ID FROM ZONE_TABLE WHERE NAME ~* '$array[$i]' AND PARENT = $out[0]");
		$num = $str->execute;
		if($str->err){
			my $err = $DBI::errstr;
			&IPDBError(-1,"Can't query Zone ID $err");
		}
		$num =~ s/E.*//g;
                unless($num){
                        $str = $conn->prepare("INSERT INTO ZONE_TABLE (NAME,PARENT,own) VALUES ('$array[$i]',$out[0],'f')");
			$str->execute;
			if($str->err){
				my $err = $DBI::errstr;
				&IPDBError(-1,"Can't Insert ZONE $err");
			}
                        $str = $conn->prepare("SELECT ID FROM ZONE_TABLE WHERE NAME = '$array[$i]' AND PARENT = $out[0]");
			$str->execute;
			if($str->err){
				my $err = $DBI::errstr;
				&IPDBError(-1,"Can't query new Zone ID $err");
			}
			$insert = 1;
		} else {
		}
		@out = $str->fetchrow;
                $i++;
        }
	if(($array[0] eq "arpa") && $insert){
		$block = $array[2].".".$array[3].".".$array[4].".0";
	}
        return($out[0]);
}

sub IncSerial(){
        my $conn = shift;
        my $zone = shift;
        my $str = $conn->prepare("SELECT SERIAL FROM ZONE_TABLE WHERE ID = $zone");
	my $num = $str->execute;
	$num =~ s/E.*//g;
        if($num){
		my @out = $str->fetchrow;
                my $serial = $out[0];
                if($serial){
                        $serial++;
                        $str = $conn->prepare("UPDATE ZONE_TABLE SET SERIAL = $serial WHERE ID = $zone");
			$str->execute;
			if($str->err){
				my $err = $DBI::errstr;
				&IPDBError(-1,"Can't set serial $err");
			}
                } else {
                        $str = $conn->prepare("UPDATE ZONE_TABLE SET SERIAL = 1 WHERE ID = $zone");
			$str->execute;
			if($str->err){
				my $err = $DBI::errstr;
				&IPDBError(-1,"Could not set serial $err");
			}
                        $str = $conn->prepare("UPDATE ZONE_TABLE SET REFRESH = 7200 WHERE ID = $zone");
			$str->execute;
			if($str->err){
				my $err = $DBI::errstr;
				&IPDBError(-1,"Could not set refresh $err");
			}
                        $str = $conn->prepare("UPDATE ZONE_TABLE SET RETRY = 1800 WHERE ID = $zone");
			$str->execute;
			if($str->err){
				my $err = $DBI::errstr;
				&IPDBError(-1,"Could not set retry $err");
			}
                        $str = $conn->prepare("UPDATE ZONE_TABLE SET EXPIRE = 604800 WHERE ID = $zone");
			$str->execute;
			if($str->err){
				my $err = $DBI::errstr;
				&IPDBError(-1,"Could not set expire $err");
			}
                        $str = $conn->prepare("UPDATE ZONE_TABLE SET TTL = 3600 WHERE ID = $zone");
			$str->execute;
			if($str->err){
				my $err = $DBI::errstr;
				&IPDBError(-1,"Could not set TTL $err");
			}
                }
        } else {
		&IPDBError(-1,"Could not incrament Serial #");
        }
}


sub DNSHead(){
        my $conn = shift;
        my $zone = shift;
	my $rev = shift;
	my $str;
	if($rev){
		$str = $conn->prepare("SELECT SERIAL,REFRESH,RETRY,EXPIRE,TTL,ID FROM ZONE_TABLE WHERE REVERSE_BLOCK = $zone");
	} else {
		$str = $conn->prepare("SELECT SERIAL,REFRESH,RETRY,EXPIRE,TTL,ID FROM ZONE_TABLE WHERE ID = $zone");
	}
	my $num = $str->execute;
	if(my $err = $str->err){&IPDBError(-1,"Could not get Zone info $err"); }	
	my @out = $str->fetchrow;
        my $serial = $out[0];
        my $refresh = $out[1];
        my $retry = $out[2];
        my $expire = $out[3];
        my $ttl = $out[4];
        my $id = $out[5];

        print "@		IN		SOA     gblx.net. dns.gblx.net. (\n";
        print "			$serial		;Serial\n";
        print "			$refresh	;Refresh\n";
        print "			$retry		;Retry\n";
        print "			$expire		;Expire\n";
        print "			$ttl   )	;TTL\n";
        print "\$INCLUDE ns\n";
        my $ORIG = GetZoneString($conn,$id);
        if($rev){print "\$ORIGIN $ORIG\n";}
print <<EOF;
;/*---------------------------------------------------*/
;       WARNING WARNING WARNING WARNING WARNING
; 
;       This reverse file is auto-generated. Any
;       manual changes WILL be lost. All changes
;       Are to be done via the FreeIPDB tool
;
;/*---------------------------------------------------*/
EOF
}

sub WalkZone(){
	my $conn = shift;
	my $zone = shift;
	my $query = "SELECT TYPE,BLOCK,INDEX,HOSTNAME,TEXT,IP FROM zone_record_table WHERE ZONE = $zone";
	my $str = $conn->prepare($query);
	my $num = $str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not get Zone list $err"); 
	}	
	my @out;
	while(@out = $str->fetchrow){
		$type = $out[0];
		$block = $out[1];
		$index = $out[2];
		$hostname = $out[3];
		$text = $out[4];
		$ip = $out[5];
		@Block = &GetBlockFromID($conn,$block);
		$address = deci2ip(($Block[0] + $index),&Version($conn,$Block[2]));
		if($type == 1){
			print "$hostname		IN	A	$address\n";
		} elsif ($type == 2) {


		}
	}
}

sub WalkReverseBlocks(){
        my $conn = shift;
        my $zone = shift;
        my $str = $conn->prepare("SELECT BLOCK,CHILDL,CHILDR FROM IPDB WHERE ID = $zone");
	my $num = $str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not query IPDB $err"); 
	}	
	$num =~ s/E.*//g;
        if($num){
		my @out = $str->fetchrow;
                my $childl = $out[1];
                my $childr = $out[2];
                if($childr){
                        &WalkReverseBlocks($conn,$childl);
                        &WalkReverseBlocks($conn,$childr);
                } else  {
                        my $block = $out[0];
                        my $str2 = $conn->prepare("SELECT HOSTNAME,INDEX,ZONE FROM ZONE_RECORD_TABLE WHERE BLOCK = $zone AND TYPE = 2 ORDER BY INDEX ASC");
                        my $num = $str2->execute;
                        while(@out = $str2->fetchrow){
                                my $text = $out[0];
                                my $index = $out[1];
                                my $zone = $out[2];
                                my $ip = deci2ip($block + $index,4);
                                $zone = &GetZoneString($conn,$zone);
                                $ip = LastOctet($ip);
                                print "$ip              IN      PTR     $text.\n";
                                $i++;
                        }
                }
        }
}

sub LastOctet(){
        my $in = shift;
        my @array = split(/\./,$in);
        return($array[3]);
}

sub GetZoneString(){
        $conn = shift;
        $block = shift;
        my @out;
	my $zn = "";
	my $foo = "";
        my $str = $conn->prepare("SELECT NAME,PARENT FROM ZONE_TABLE WHERE ID = $block");
	my $num = $str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not query Zone table $err"); 
	}	
	$num =~ s/E.*//g;
        if($num){
		my @out = $str->fetchrow;
                my $name = $out[0];
                my $parent = $out[1];
                if($parent){
                        $zn = &GetZoneString($conn,$parent);
                        $foo = $name.".".$zn;
                } else {
                        $foo = $name;
                }
                $foo =~ s/^0$/./g;
		$foo =~ s/\.\././g;
		$str->finish;
                return($foo);
        }
	return("");
}

sub Toggle(){
	my $in = shift;
        if($in){
                print "   <TR BGCOLOR=$config{listcolorA}>";
                return(0);
        } else {
                print "   <TR BGCOLOR=$config{listcolorB}>";
                return(1);
        }
}

sub DNSTable(){
	my $conn = shift;
	my $block = shift;
	my $script = shift;
	print "<TR><TD></TD><TD COLSPAN=5><TABLE BORDER>\n";
	print "<TR><TH>Hostname</TH><TH>IP</TH><TH>Type</TH></TR>\n";
	my $query = "SELECT ID,HOSTNAME,INDEX,ZONE,TYPE FROM ZONE_RECORD_TABLE WHERE BLOCK = $block";
	my $str = $conn->prepare($query);
	my $num = $str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not query dns records $err"); 
	}	
	while(@out = $str->fetchrow){
		my $id = $out[0];
		my $hostname = $out[1].".".&GetZoneString($conn,$out[3]);
		my @info = &GetBlockFromID($conn,$block);
		my $ver = &VersionFromRegion($conn,$info[2]);
		my $ip = deci2ip($info[0] + $out[2],$ver);
		if($out[4]){
			if($out[4] == 1){
				$type = "Forward";
			} elsif($out[4] == 2){
				$type = "Reverse";
			}
		}
		print "<TR><TD>$hostname</TD><TD>$ip</TD><TD>$type</TD><TD>";
		print "<FORM ACTION=$script METHOD=POST>\n";
		print "<INPUT TYPE=HIDDEN NAME=ACTION VALUE=DELETEDNS>\n";
		print "<INPUT TYPE=HIDDEN NAME=ID VALUE=$id>\n";
		print "<INPUT TYPE=SUBMIT VALUE=\"Delete\">\n";
		print "</FORM>\n";
		print "</TR>\n";
	}
	print "</TABLE></TR>\n";
	$str->finish;
}

sub ZoneTable(){
	my $conn = shift;
	my $script = shift;
	print "<TR><TH>Zone</TH><TH>Type</TH><TH>Serial</TH><TH>Retry/Refresh/";
	print "Expire/TTL</TH><TH>Status</TH><TH>State-change/<BR>Edit</TH></TR>\n";
	print "<FORM ACTION=$script METHOD=POST>\n";
	print "<INPUT TYPE=HIDDEN NAME=ACTION VALUE=ZONEED>\n";
	my $query = "SELECT ID,OWN,SERIAL,RETRY,REFRESH,EXPIRE,TTL,REVERSE_BLOCK FROM ZONE_TABLE";
	my $str = $conn->prepare($query);
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not query zone $err"); 
	}	
	my $num = $str->execute;
	my @out;
	while(@out = $str->fetchrow){
		my $id = $out[0];
		my $zone = &GetZoneString($conn,$id);
		my $serial = $out[2];
		if($out[7]){
			$type = "Reverse";
		} else {
			$type = "Forward";
		}
		if(&CheckZone($conn,$id) && $out[3] ){
			my $times = $out[3]." / ".$out[4]." / ".$out[5]." / ".$out[6];
			print "<TR><TD>$zone</TD><TD>$type</TD><TD>$serial</TD><TD>$times</TD>\n";
			if($out[1]){
				$status = "<TD BGCOLOR=#00FF00>Active</TD>";
				print "$status";
			} else {
				$status = "<TD BGCOLOR=#FF0000>Disabled</TD>";
				print "$status";
			}
			print "<TD>";
			print "<INPUT TYPE=CHECKBOX NAME=ZONE[$id]> /\n";
			print "<INPUT TYPE=RADIO NAME=ZONEEDIT VALUE=$id>\n";
			print "</TD></TR>";
		}
	}
	$str->finish;
	print "<TR><TD COLSPAN=5>";
	print "<INPUT TYPE=SUBMIT VALUE=\"Change State(s)\">";
	print "</TR>";
	print "</FORM>";
}

sub ToggleZone(){
	my $conn = shift;
	my $zone = shift;
	#Get current state
	my $query = "SELECT OWN FROM ZONE_TABLE WHERE ID = $zone";
	my $str = $conn->prepare($query);
	my $num = $str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not query block's current state $err"); 
	}
	@out = $str->fetchrow;
	#Set new state.
	if($out[0]){
		$query = "UPDATE ZONE_TABLE SET OWN = 'f' WHERE ID = $zone";
	} else {
		$query = "UPDATE ZONE_TABLE SET OWN = 't' WHERE ID = $zone";
	}
	$str = $conn->prepare($query);
	$num = $str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not change block's current state $err"); 
	}
}

sub DeleteDNSRecord(){
	my $conn = shift;
	my $id = shift;
	if($id){
		my $query = "DELETE FROM ZONE_RECORD_TABLE WHERE ID = $id";
		my $str = $conn->prepare($query);
		my $num = $str->execute;
		if($str->err){
			my $err = $DBI::errstr;
			&IPDBError(-1,"Could not Delete record $err"); 
		}
		return(0);
	} else {
		&IPDBError(-1,"No Zone_Record ID to delete");
	}
}

sub RwhoisForm(){
	my $conn = shift;
	my $block = shift;
	my $netname = shift;
	# Choose known org || Create New one.
}


sub DataDump(){
	my $conn = shift;
	my $block = shift;
	my $bits = shift;
	my $region = shift;
	$ip = ip2deci($block);
	my $id = &GetBlockId($conn,$ip,$bits,$region);
	if($id){
		&DumpHead();
		&BlockDump($conn,$id);
	} else {
		&IPDBError(-1,"Could not get Block ID");
	}
}

sub DumpHead(){
	print "<PRE>\n";
	print "IP Address:Netmask(bits):Region:$config{custnum_f}:$config{custname_f}:Allocated Timestamp\n";
	print "==========================================================\n";
}

sub BlockDump(){
	my $conn = shift;
	my $block = shift;
	# Check if block is child or parent
	my $query = "SELECT BLOCK,BITS,REGION,CHILDL,CHILDR,custnum,custdesc,ALLOCATED FROM IPDB WHERE ID = $block";
	my $str = $conn->prepare($query);
	my $num = $str->execute;
	if($str->err){
		my $err = $DBI::errstr;
		&IPDBError(-1,"Could not get Block record $err"); 
	}
	my @out;
	if(@out = $str->fetchrow){
		if($out[3]){
			&BlockDump($conn,$out[3]);
			&BlockDump($conn,$out[4]);
		} else {
			my $ip = &deci2ip($out[0],4);
			my $region = &LookupRegion($conn,$out[2]);
			print "$ip:$out[1]:$region:$out[5]:$out[6]:$out[7]\n";
		}
	
	} else {	
		&IPDBError(-1,"No result for block");
	}
}

1;
