#!/usr/bin/perl -w
#                _____              ___ ____     _ _
#               |  ___| __ ___  ___|_ _|  _ \ __| | |__
#               | |_ | '__/ _ \/ _ \| || |_) / _` | '_ \
#               |  _|| | |  __/  __/| ||  __/ (_| | |_) |
#               |_|  |_|  \___|\___|___|_|   \__,_|_.__/
#
#	rev_gen_tool.pl-$Name:  $-$Revision: 1.11 $ $Date: 2002/03/10 03:53:58 $ <$Author: bapril $@freeipdb.org>
######################################################################


# Trial tool to generate Reverse DNS files from IPDB/DNS.
require 'ipdb_httpcgi.pl';
use config;
%config = config::config();

foreach $arg (@ARGV){
	if($arg eq "-q"){ $quiet = 1;}
	if($arg eq "-?" || $arg eq "-h"){
		print "Usage: rev_gen_tool.pl [-q] [-h]\n";
		print "\t-h this help screen.\n";
		print "\t-q operate queitly (for cron and such).\n";
		exit();
	}
}

unless($config{allowDNS}){
	die("FreeIPdb is not configured for DNS.\n")
}

#Check for DNS dir
open(CONFIG,">$config{dnsdir}/$config{dnsinclude}")|| die "Can't open $config{dnsdir}/$config{dnsinclude} for writing $!";

use DBI;
my $conn = DBI->connect("DBI:Pg:dbname=$config{dbname};host=$config{dbhost};port=$config{dbport}", "$config{dbuser}", "$config{dbpass}",);

#Walk DB for Reverse Files.

my $query = "SELECT ID,reverse_block FROM ZONE_TABLE WHERE reverse_block NOTNULL AND OWN = 't'";
my $str = $conn->prepare($query);
my $num = $str->execute;
my @out;
while(@out = $str->fetchrow){
	my $id = $out[0];
	my $rev_zone = $out[1];
	my $zonename = &GetZoneString($conn,$id);
	$zonename =~ s/.$//g;
	print "ZONE $zonename\n" unless $quiet;
	open(FILE,">$config{dnsdir}$zonename")|| die "Can't open $config{dnsdir}$zonename for writing $!";
	select(FILE);
	&DNSHead($conn,$rev_zone,1);
#	Walk blocks under zone.
	&WalkReverseBlocks($conn,$rev_zone);
	select(STDOUT);
	close(FILE);
	print CONFIG "zone \"$zonename\" in {\n";
        print CONFIG "\ttype master;\n";
        print CONFIG "\tfile \"$config{dnsdir}$zonename\";\n";
	print CONFIG "};\n";
}

#Walk DB for Forward File.

$query = "SELECT ID FROM ZONE_TABLE WHERE OWN = 't' AND reverse_block IS NULL";
$str = $conn->prepare($query);
$num = $str->execute;
while(@out = $str->fetchrow){
	my $id = $out[0];
	my $zonename = &GetZoneString($conn,$id);
	open(FILE,">$config{dnsdir}$zonename")|| die "Can't open $config{dnsdir}$zonename for writing $!";
	select(FILE);
	# Walk the Zone.
	&DNSHead($conn,$id);
	&WalkZone($conn,$id);
	select(STDOUT);
	close(FILE);
	print "ZONE $zonename\n" unless $quiet;
	print CONFIG "zone \"$zonename\" in {\n";
	print CONFIG "\ttype master;\n";
	print CONFIG "\tfile \"$config{dnsdir}$zonename\";\n";
	print CONFIG "};\n";
}


close(CONFIG);
$str->finish;
undef $str;
$conn->disconnect;
